package b4a.tts1;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "b4a.tts1", "b4a.tts1.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.tts1", "b4a.tts1.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "b4a.tts1.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
//        try {
//            if (processBA.subExists("activity_actionbarhomeclick")) {
//                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
//                    getClass().getMethod("getActionBar").invoke(this), true);
//                BA.Log("adding event");
//            }
//        } catch (Exception e) {
//            e.printStackTrace();
//        }
		return true;
	}   
// @Override
// public boolean onOptionsItemSelected(android.view.MenuItem item) {
//    if (item.getItemId() == 16908332) {
//        processBA.raiseEvent(null, "activity_actionbarhomeclick");
//        return true;
//    }
//    else
//        return super.onOptionsItemSelected(item); 
//}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static b4a.tts1.contactsutils _cu = null;
public static anywheresoftware.b4a.obejcts.TTS _tts1 = null;
public anywheresoftware.b4a.objects.SpinnerWrapper _cb_ordem_recebidos = null;
public anywheresoftware.b4a.objects.LabelWrapper _lbl_ordem = null;
public anywheresoftware.b4a.objects.PanelWrapper _paregistros = null;
public flm.b4a.ultimatelistview.UltimateListViewWrapper _ulv_registro = null;
public flm.b4a.ultimatelistview.Animator _animator_registros = null;
public anywheresoftware.b4a.objects.collections.List _gm_registros_ligacoes = null;
public anywheresoftware.b4a.keywords.constants.TypefaceWrapper _tf = null;
public anywheresoftware.b4a.objects.collections.Map _images = null;
public anywheresoftware.b4a.objects.PanelWrapper _pamain = null;
public anywheresoftware.b4a.objects.LabelWrapper _label1 = null;
public anywheresoftware.b4a.objects.LabelWrapper _lbl_registro_item = null;
public anywheresoftware.b4a.samples.httputils2.httputils2service _httputils2service = null;

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static String  _activity_create(boolean _firsttime) throws Exception{
anywheresoftware.b4a.objects.drawable.ColorDrawable _cd = null;
 //BA.debugLineNum = 41;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 43;BA.debugLine="Activity.LoadLayout(\"Main\")";
mostCurrent._activity.LoadLayout("Main",mostCurrent.activityBA);
 //BA.debugLineNum = 44;BA.debugLine="If FirstTime Then";
if (_firsttime) { 
 //BA.debugLineNum = 45;BA.debugLine="cu.Initialize";
_cu._initialize(processBA);
 };
 //BA.debugLineNum = 47;BA.debugLine="Cb_Ordem_Recebidos.Initialize(\"Cb_Ordem_Recebidos\")";
mostCurrent._cb_ordem_recebidos.Initialize(mostCurrent.activityBA,"Cb_Ordem_Recebidos");
 //BA.debugLineNum = 48;BA.debugLine="Lbl_Ordem.Initialize(\"\")";
mostCurrent._lbl_ordem.Initialize(mostCurrent.activityBA,"");
 //BA.debugLineNum = 50;BA.debugLine="Images.Initialize";
mostCurrent._images.Initialize();
 //BA.debugLineNum = 51;BA.debugLine="Images.Put(\"Ligar_black\", LoadBitmapSample(File.DirAssets, \"phone_black.jpg\", 50dip, 50dip))";
mostCurrent._images.Put((Object)("Ligar_black"),(Object)(anywheresoftware.b4a.keywords.Common.LoadBitmapSample(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"phone_black.jpg",anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (50)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (50))).getObject()));
 //BA.debugLineNum = 52;BA.debugLine="Images.Put(\"xis_black\", LoadBitmapSample(File.DirAssets, \"xis_pblack.jpg\", 50dip, 50dip))";
mostCurrent._images.Put((Object)("xis_black"),(Object)(anywheresoftware.b4a.keywords.Common.LoadBitmapSample(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"xis_pblack.jpg",anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (50)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (50))).getObject()));
 //BA.debugLineNum = 54;BA.debugLine="PaRegistros.Initialize(\"\")";
mostCurrent._paregistros.Initialize(mostCurrent.activityBA,"");
 //BA.debugLineNum = 55;BA.debugLine="Activity.AddView(PaRegistros,0,0,100%x,100%y)";
mostCurrent._activity.AddView((android.view.View)(mostCurrent._paregistros.getObject()),(int) (0),(int) (0),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (100),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (100),mostCurrent.activityBA));
 //BA.debugLineNum = 56;BA.debugLine="Dim cd As ColorDrawable";
_cd = new anywheresoftware.b4a.objects.drawable.ColorDrawable();
 //BA.debugLineNum = 57;BA.debugLine="cd.Initialize(Colors.Green, 16dip)";
_cd.Initialize(anywheresoftware.b4a.keywords.Common.Colors.Green,anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (16)));
 //BA.debugLineNum = 58;BA.debugLine="gm_Registros_Ligacoes.Initialize";
mostCurrent._gm_registros_ligacoes.Initialize();
 //BA.debugLineNum = 65;BA.debugLine="ULV_Registro.Initialize(0, 0, \"\", \"ULV_Registro\")";
mostCurrent._ulv_registro.Initialize(mostCurrent.activityBA,(byte) (0),(int) (0),"","ULV_Registro");
 //BA.debugLineNum = 66;BA.debugLine="ULV_Registro.Color = Colors.RGB(236,241,247)";
mostCurrent._ulv_registro.setColor(anywheresoftware.b4a.keywords.Common.Colors.RGB((int) (236),(int) (241),(int) (247)));
 //BA.debugLineNum = 67;BA.debugLine="Get_Registros";
_get_registros();
 //BA.debugLineNum = 68;BA.debugLine="PaRegistros.AddView(ULV_Registro, 0, 0, 100%x, 100%y)";
mostCurrent._paregistros.AddView((android.view.View)(mostCurrent._ulv_registro.getObject()),(int) (0),(int) (0),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (100),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (100),mostCurrent.activityBA));
 //BA.debugLineNum = 69;BA.debugLine="ULV_Registro.AddLayout(\"FrmRegistro_Item\", \"Reg_Item_LayoutCreator\", \"Reg_Item_ContentFiller\", 80dip, True)";
mostCurrent._ulv_registro.AddLayout("FrmRegistro_Item","Reg_Item_LayoutCreator","Reg_Item_ContentFiller",anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (80)),anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 70;BA.debugLine="ULV_Registro.BulkAddItems(gm_Registros_Ligacoes.Size, \"FrmRegistro_Item\",0)";
mostCurrent._ulv_registro.BulkAddItems(mostCurrent._gm_registros_ligacoes.getSize(),"FrmRegistro_Item",(int) (0));
 //BA.debugLineNum = 71;BA.debugLine="Cb_Ordem_Recebidos.Clear";
mostCurrent._cb_ordem_recebidos.Clear();
 //BA.debugLineNum = 72;BA.debugLine="Cb_Ordem_Recebidos.Add (\"Data\")";
mostCurrent._cb_ordem_recebidos.Add("Data");
 //BA.debugLineNum = 73;BA.debugLine="Cb_Ordem_Recebidos.Add (\"Nome\" )";
mostCurrent._cb_ordem_recebidos.Add("Nome");
 //BA.debugLineNum = 74;BA.debugLine="Cb_Ordem_Recebidos.Color = Colors.RGB(232,241,245)";
mostCurrent._cb_ordem_recebidos.setColor(anywheresoftware.b4a.keywords.Common.Colors.RGB((int) (232),(int) (241),(int) (245)));
 //BA.debugLineNum = 75;BA.debugLine="Cb_Ordem_Recebidos.TextColor = Colors.Black";
mostCurrent._cb_ordem_recebidos.setTextColor(anywheresoftware.b4a.keywords.Common.Colors.Black);
 //BA.debugLineNum = 76;BA.debugLine="Cb_Ordem_Recebidos.DropdownBackgroundColor = Colors.LightGray";
mostCurrent._cb_ordem_recebidos.setDropdownBackgroundColor(anywheresoftware.b4a.keywords.Common.Colors.LightGray);
 //BA.debugLineNum = 79;BA.debugLine="ULV_Registro.DividerHeight = 1dip";
mostCurrent._ulv_registro.setDividerHeight(anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (1)));
 //BA.debugLineNum = 80;BA.debugLine="ULV_Registro.DividerDrawable = cd";
mostCurrent._ulv_registro.setDividerDrawable((android.graphics.drawable.Drawable)(_cd.getObject()));
 //BA.debugLineNum = 81;BA.debugLine="PaRegistros.Color = Colors.Black";
mostCurrent._paregistros.setColor(anywheresoftware.b4a.keywords.Common.Colors.Black);
 //BA.debugLineNum = 82;BA.debugLine="ULV_Registro.Color = Colors.Black";
mostCurrent._ulv_registro.setColor(anywheresoftware.b4a.keywords.Common.Colors.Black);
 //BA.debugLineNum = 83;BA.debugLine="Lbl_Ordem.Color = Colors.Black";
mostCurrent._lbl_ordem.setColor(anywheresoftware.b4a.keywords.Common.Colors.Black);
 //BA.debugLineNum = 84;BA.debugLine="Lbl_Ordem.TextColor = Colors.White";
mostCurrent._lbl_ordem.setTextColor(anywheresoftware.b4a.keywords.Common.Colors.White);
 //BA.debugLineNum = 85;BA.debugLine="Cb_Ordem_Recebidos.Color = Colors.Black";
mostCurrent._cb_ordem_recebidos.setColor(anywheresoftware.b4a.keywords.Common.Colors.Black);
 //BA.debugLineNum = 86;BA.debugLine="Cb_Ordem_Recebidos.TextColor = Colors.White";
mostCurrent._cb_ordem_recebidos.setTextColor(anywheresoftware.b4a.keywords.Common.Colors.White);
 //BA.debugLineNum = 87;BA.debugLine="cd.Initialize(Colors.Blue, 16dip)";
_cd.Initialize(anywheresoftware.b4a.keywords.Common.Colors.Blue,anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (16)));
 //BA.debugLineNum = 88;BA.debugLine="ULV_Registro.PressedDrawable = cd";
mostCurrent._ulv_registro.setPressedDrawable((android.graphics.drawable.Drawable)(_cd.getObject()));
 //BA.debugLineNum = 92;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 106;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 107;BA.debugLine="Try";
try { //BA.debugLineNum = 108;BA.debugLine="If TTS1.IsInitialized = True Then";
if (_tts1.IsInitialized()==anywheresoftware.b4a.keywords.Common.True) { 
 //BA.debugLineNum = 109;BA.debugLine="TTS1.Release";
_tts1.Release();
 };
 } 
       catch (Exception e71) {
			processBA.setLastException(e71); //BA.debugLineNum = 112;BA.debugLine="Log(\"erro ao pausar tts\")";
anywheresoftware.b4a.keywords.Common.Log("erro ao pausar tts");
 };
 //BA.debugLineNum = 115;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 94;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 95;BA.debugLine="Try";
try { //BA.debugLineNum = 96;BA.debugLine="TTS1.SetLanguage(\"en\",\"\")";
_tts1.SetLanguage("en","");
 //BA.debugLineNum = 97;BA.debugLine="If TTS1.IsInitialized = False Then";
if (_tts1.IsInitialized()==anywheresoftware.b4a.keywords.Common.False) { 
 //BA.debugLineNum = 98;BA.debugLine="TTS1.Initialize(\"TTS1\")";
_tts1.Initialize(processBA,"TTS1");
 };
 } 
       catch (Exception e62) {
			processBA.setLastException(e62); //BA.debugLineNum = 101;BA.debugLine="TTS1.Initialize(\"TTS1\")";
_tts1.Initialize(processBA,"TTS1");
 };
 //BA.debugLineNum = 104;BA.debugLine="End Sub";
return "";
}
public static String  _cb_ordem_recebidos_itemclick(int _position,Object _value) throws Exception{
 //BA.debugLineNum = 306;BA.debugLine="Sub Cb_Ordem_Recebidos_ItemClick (Position As Int, Value As Object)";
 //BA.debugLineNum = 308;BA.debugLine="End Sub";
return "";
}
public static String  _get_registros() throws Exception{
anywheresoftware.b4a.phone.CallLogWrapper _calllog = null;
String _xordem = "";
 //BA.debugLineNum = 190;BA.debugLine="Sub Get_Registros";
 //BA.debugLineNum = 191;BA.debugLine="Dim CallLog As CallLog";
_calllog = new anywheresoftware.b4a.phone.CallLogWrapper();
 //BA.debugLineNum = 192;BA.debugLine="Dim xOrdem As String";
_xordem = "";
 //BA.debugLineNum = 194;BA.debugLine="gm_Registros_Ligacoes.Clear";
mostCurrent._gm_registros_ligacoes.Clear();
 //BA.debugLineNum = 195;BA.debugLine="gm_Registros_Ligacoes = CallLog.GetAll(200) 'Get the last 100 calls";
mostCurrent._gm_registros_ligacoes = _calllog.GetAll((int) (200));
 //BA.debugLineNum = 196;BA.debugLine="xOrdem = Cb_Ordem_Recebidos.SelectedItem";
_xordem = mostCurrent._cb_ordem_recebidos.getSelectedItem();
 //BA.debugLineNum = 197;BA.debugLine="Select xOrdem";
switch (BA.switchObjectToInt(_xordem,"Date","Name")) {
case 0:
 //BA.debugLineNum = 199;BA.debugLine="gm_Registros_Ligacoes.SortTypeCaseInsensitive ( \"Date\", False )";
mostCurrent._gm_registros_ligacoes.SortTypeCaseInsensitive("Date",anywheresoftware.b4a.keywords.Common.False);
 break;
case 1:
 //BA.debugLineNum = 201;BA.debugLine="gm_Registros_Ligacoes.SortTypeCaseInsensitive ( \"CachedName\", True )";
mostCurrent._gm_registros_ligacoes.SortTypeCaseInsensitive("CachedName",anywheresoftware.b4a.keywords.Common.True);
 break;
}
;
 //BA.debugLineNum = 204;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        anywheresoftware.b4a.samples.httputils2.httputils2service._process_globals();
main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _globals() throws Exception{
 //BA.debugLineNum = 23;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 27;BA.debugLine="Private Cb_Ordem_Recebidos As Spinner";
mostCurrent._cb_ordem_recebidos = new anywheresoftware.b4a.objects.SpinnerWrapper();
 //BA.debugLineNum = 28;BA.debugLine="Private Lbl_Ordem As Label";
mostCurrent._lbl_ordem = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 29;BA.debugLine="Private PaRegistros As Panel";
mostCurrent._paregistros = new anywheresoftware.b4a.objects.PanelWrapper();
 //BA.debugLineNum = 30;BA.debugLine="Dim ULV_Registro As UltimateListView";
mostCurrent._ulv_registro = new flm.b4a.ultimatelistview.UltimateListViewWrapper();
 //BA.debugLineNum = 31;BA.debugLine="Dim Animator_Registros As UltimateLVAnimator";
mostCurrent._animator_registros = new flm.b4a.ultimatelistview.Animator();
 //BA.debugLineNum = 32;BA.debugLine="Dim gm_Registros_Ligacoes As List";
mostCurrent._gm_registros_ligacoes = new anywheresoftware.b4a.objects.collections.List();
 //BA.debugLineNum = 33;BA.debugLine="Dim Tf As Typeface";
mostCurrent._tf = new anywheresoftware.b4a.keywords.constants.TypefaceWrapper();
 //BA.debugLineNum = 34;BA.debugLine="Dim Images As Map";
mostCurrent._images = new anywheresoftware.b4a.objects.collections.Map();
 //BA.debugLineNum = 36;BA.debugLine="Private PaMain As Panel";
mostCurrent._pamain = new anywheresoftware.b4a.objects.PanelWrapper();
 //BA.debugLineNum = 37;BA.debugLine="Private Label1 As Label";
mostCurrent._label1 = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 38;BA.debugLine="Private Lbl_Registro_Item As Label";
mostCurrent._lbl_registro_item = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 39;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 15;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 18;BA.debugLine="Dim cu As ContactsUtils";
_cu = new b4a.tts1.contactsutils();
 //BA.debugLineNum = 19;BA.debugLine="Dim TTS1 As TTS";
_tts1 = new anywheresoftware.b4a.obejcts.TTS();
 //BA.debugLineNum = 21;BA.debugLine="End Sub";
return "";
}
public static String  _reg_item_contentfiller(long _itemid,String _layoutname,anywheresoftware.b4a.objects.PanelWrapper _layoutpanel,int _position) throws Exception{
anywheresoftware.b4a.phone.CallLogWrapper.CallItem _c = null;
String _xnome = "";
String _calltype = "";
String _name = "";
anywheresoftware.b4a.objects.LabelWrapper _lbl = null;
anywheresoftware.b4a.objects.LabelWrapper _lbl1 = null;
anywheresoftware.b4a.objects.LabelWrapper _lbl2 = null;
anywheresoftware.b4a.objects.ImageViewWrapper _iv = null;
 //BA.debugLineNum = 121;BA.debugLine="Sub Reg_Item_ContentFiller(ItemID As Long, LayoutName As String, LayoutPanel As Panel, Position As Int)";
 //BA.debugLineNum = 123;BA.debugLine="Dim c As CallItem";
_c = new anywheresoftware.b4a.phone.CallLogWrapper.CallItem();
 //BA.debugLineNum = 124;BA.debugLine="Dim xNome As String";
_xnome = "";
 //BA.debugLineNum = 125;BA.debugLine="c = gm_Registros_Ligacoes.Get(Position)";
_c = (anywheresoftware.b4a.phone.CallLogWrapper.CallItem)(mostCurrent._gm_registros_ligacoes.Get(_position));
 //BA.debugLineNum = 126;BA.debugLine="Dim callType, name As String";
_calltype = "";
_name = "";
 //BA.debugLineNum = 127;BA.debugLine="Select c.callType";
switch (BA.switchObjectToInt(_c.CallType,_c.TYPE_INCOMING,_c.TYPE_MISSED,_c.TYPE_OUTGOING)) {
case 0:
 //BA.debugLineNum = 129;BA.debugLine="callType=\"Received\"";
_calltype = "Received";
 break;
case 1:
 //BA.debugLineNum = 131;BA.debugLine="callType = \"Not Answered\"";
_calltype = "Not Answered";
 break;
case 2:
 //BA.debugLineNum = 133;BA.debugLine="callType = \"Call Made\"";
_calltype = "Call Made";
 break;
}
;
 //BA.debugLineNum = 135;BA.debugLine="Dim lbl As Label = LayoutPanel.GetView(0) 'First view in the panel";
_lbl = new anywheresoftware.b4a.objects.LabelWrapper();
_lbl.setObject((android.widget.TextView)(_layoutpanel.GetView((int) (0)).getObject()));
 //BA.debugLineNum = 136;BA.debugLine="xNome = c.CachedName";
_xnome = _c.CachedName;
 //BA.debugLineNum = 137;BA.debugLine="If xNome.Trim = \"\" Then";
if ((_xnome.trim()).equals("")) { 
 //BA.debugLineNum = 138;BA.debugLine="xNome = \"Unknow\"";
_xnome = "Unknow";
 };
 //BA.debugLineNum = 140;BA.debugLine="lbl.Text = xNome";
_lbl.setText((Object)(_xnome));
 //BA.debugLineNum = 141;BA.debugLine="lbl.Tag = c.Number";
_lbl.setTag((Object)(_c.Number));
 //BA.debugLineNum = 143;BA.debugLine="lbl.TextSize = 18";
_lbl.setTextSize((float) (18));
 //BA.debugLineNum = 144;BA.debugLine="lbl.Typeface = Tf.CreateNew(Typeface.SANS_SERIF, Typeface.STYLE_BOLD)";
_lbl.setTypeface(mostCurrent._tf.CreateNew(anywheresoftware.b4a.keywords.Common.Typeface.SANS_SERIF,anywheresoftware.b4a.keywords.Common.Typeface.STYLE_BOLD));
 //BA.debugLineNum = 146;BA.debugLine="Dim lbl1 As Label = LayoutPanel.GetView(1) 'First view in the panel";
_lbl1 = new anywheresoftware.b4a.objects.LabelWrapper();
_lbl1.setObject((android.widget.TextView)(_layoutpanel.GetView((int) (1)).getObject()));
 //BA.debugLineNum = 147;BA.debugLine="lbl1.Text = \"[ \" & callType & \" ] - \" & c.Number";
_lbl1.setText((Object)("[ "+_calltype+" ] - "+_c.Number));
 //BA.debugLineNum = 148;BA.debugLine="lbl1.Tag = c.Number";
_lbl1.setTag((Object)(_c.Number));
 //BA.debugLineNum = 150;BA.debugLine="lbl1.TextSize = 16";
_lbl1.setTextSize((float) (16));
 //BA.debugLineNum = 152;BA.debugLine="DateTime.DateFormat = \"dd/MM/yy - HH:mm:ss\"";
anywheresoftware.b4a.keywords.Common.DateTime.setDateFormat("dd/MM/yy - HH:mm:ss");
 //BA.debugLineNum = 153;BA.debugLine="Dim lbl2 As Label = LayoutPanel.GetView(2) 'First view in the panel";
_lbl2 = new anywheresoftware.b4a.objects.LabelWrapper();
_lbl2.setObject((android.widget.TextView)(_layoutpanel.GetView((int) (2)).getObject()));
 //BA.debugLineNum = 154;BA.debugLine="lbl2.Text = DateTime.Date(c.Date) &  \"  ( \" & c.Duration & \" seg )\"";
_lbl2.setText((Object)(anywheresoftware.b4a.keywords.Common.DateTime.Date(_c.Date)+"  ( "+BA.NumberToString(_c.Duration)+" seg )"));
 //BA.debugLineNum = 155;BA.debugLine="lbl2.Tag = c.Number";
_lbl2.setTag((Object)(_c.Number));
 //BA.debugLineNum = 157;BA.debugLine="lbl2.TextSize = 16";
_lbl2.setTextSize((float) (16));
 //BA.debugLineNum = 160;BA.debugLine="Dim IV As ImageView";
_iv = new anywheresoftware.b4a.objects.ImageViewWrapper();
 //BA.debugLineNum = 161;BA.debugLine="IV.Initialize (\"im_phone_registro\")";
_iv.Initialize(mostCurrent.activityBA,"im_phone_registro");
 //BA.debugLineNum = 166;BA.debugLine="IV.Tag = c.Number";
_iv.setTag((Object)(_c.Number));
 //BA.debugLineNum = 167;BA.debugLine="IV.Gravity = Gravity.FILL";
_iv.setGravity(anywheresoftware.b4a.keywords.Common.Gravity.FILL);
 //BA.debugLineNum = 169;BA.debugLine="lbl.TextColor = Colors.White";
_lbl.setTextColor(anywheresoftware.b4a.keywords.Common.Colors.White);
 //BA.debugLineNum = 170;BA.debugLine="lbl1.TextColor = Colors.White";
_lbl1.setTextColor(anywheresoftware.b4a.keywords.Common.Colors.White);
 //BA.debugLineNum = 171;BA.debugLine="lbl2.TextColor = Colors.White";
_lbl2.setTextColor(anywheresoftware.b4a.keywords.Common.Colors.White);
 //BA.debugLineNum = 172;BA.debugLine="Try";
try { //BA.debugLineNum = 173;BA.debugLine="IV.Bitmap = Images.Get(\"Ligar_black\")";
_iv.setBitmap((android.graphics.Bitmap)(mostCurrent._images.Get((Object)("Ligar_black"))));
 } 
       catch (Exception e118) {
			processBA.setLastException(e118); };
 //BA.debugLineNum = 186;BA.debugLine="LayoutPanel.AddView (IV,100%x-55dip,10dip,37dip,37dip)";
_layoutpanel.AddView((android.view.View)(_iv.getObject()),(int) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (100),mostCurrent.activityBA)-anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (55))),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (10)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (37)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (37)));
 //BA.debugLineNum = 188;BA.debugLine="End Sub";
return "";
}
public static String  _reg_item_layoutcreator(String _layoutname,anywheresoftware.b4a.objects.PanelWrapper _layoutpanel) throws Exception{
 //BA.debugLineNum = 116;BA.debugLine="Sub Reg_Item_LayoutCreator(LayoutName As String, LayoutPanel As Panel)";
 //BA.debugLineNum = 118;BA.debugLine="LayoutPanel.LoadLayout(\"FrmRegistro_Item\")";
_layoutpanel.LoadLayout("FrmRegistro_Item",mostCurrent.activityBA);
 //BA.debugLineNum = 119;BA.debugLine="End Sub";
return "";
}
public static String  _tts1_ready(boolean _success) throws Exception{
 //BA.debugLineNum = 287;BA.debugLine="Sub TTS1_Ready (Success As Boolean)";
 //BA.debugLineNum = 288;BA.debugLine="If Success  Then";
if (_success) { 
 //BA.debugLineNum = 291;BA.debugLine="Try";
try { //BA.debugLineNum = 292;BA.debugLine="If TTS1.SetLanguage(\"en\" , \"\") = False Then  'en.fr,de";
if (_tts1.SetLanguage("en","")==anywheresoftware.b4a.keywords.Common.False) { 
 //BA.debugLineNum = 293;BA.debugLine="ToastMessageShow( \"TTS library not found\", True)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("TTS library not found",anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 294;BA.debugLine="Return";
if (true) return "";
 };
 } 
       catch (Exception e201) {
			processBA.setLastException(e201); //BA.debugLineNum = 297;BA.debugLine="Return";
if (true) return "";
 };
 }else {
 //BA.debugLineNum = 302;BA.debugLine="Msgbox(\"Error initializing TTS engine.\", \"\")";
anywheresoftware.b4a.keywords.Common.Msgbox("Error initializing TTS engine.","",mostCurrent.activityBA);
 };
 //BA.debugLineNum = 304;BA.debugLine="End Sub";
return "";
}
public static String  _ulv_registro_itemlongclick(long _itemid,int _position,anywheresoftware.b4a.objects.PanelWrapper _clickedpanel) throws Exception{
String _xnome = "";
String _xdata = "";
String _xhoras = "";
String _xnumero = "";
String _xduracao = "";
String _xtexto = "";
String _xtemp = "";
int _xint = 0;
anywheresoftware.b4a.phone.CallLogWrapper.CallItem _c = null;
String _calltype = "";
String _name = "";
int _i = 0;
String[] _dias = null;
String[] _meses = null;
String _xdia = "";
String _xmes = "";
String _xsemana = "";
String _xano = "";
String _xhora = "";
String _xminuto = "";
int _xint_dia = 0;
int _xint_mes = 0;
 //BA.debugLineNum = 206;BA.debugLine="Sub ULV_Registro_ItemLongClick(ItemID As Long, Position As Int, ClickedPanel As Panel)";
 //BA.debugLineNum = 208;BA.debugLine="Dim xNome,  xData, XHoras, xNumero, xDuracao, xTexto , xTemp As String";
_xnome = "";
_xdata = "";
_xhoras = "";
_xnumero = "";
_xduracao = "";
_xtexto = "";
_xtemp = "";
 //BA.debugLineNum = 209;BA.debugLine="Dim xInt As Int";
_xint = 0;
 //BA.debugLineNum = 211;BA.debugLine="Dim c As CallItem";
_c = new anywheresoftware.b4a.phone.CallLogWrapper.CallItem();
 //BA.debugLineNum = 212;BA.debugLine="c = gm_Registros_Ligacoes.Get(Position)";
_c = (anywheresoftware.b4a.phone.CallLogWrapper.CallItem)(mostCurrent._gm_registros_ligacoes.Get(_position));
 //BA.debugLineNum = 213;BA.debugLine="Dim callType, name As String";
_calltype = "";
_name = "";
 //BA.debugLineNum = 214;BA.debugLine="Select c.callType";
switch (BA.switchObjectToInt(_c.CallType,_c.TYPE_INCOMING,_c.TYPE_MISSED,_c.TYPE_OUTGOING)) {
case 0:
 //BA.debugLineNum = 216;BA.debugLine="callType=\"Received from\"";
_calltype = "Received from";
 break;
case 1:
 //BA.debugLineNum = 218;BA.debugLine="callType = \"Not answered from\"";
_calltype = "Not answered from";
 break;
case 2:
 //BA.debugLineNum = 220;BA.debugLine="callType = \"Call to\"";
_calltype = "Call to";
 break;
}
;
 //BA.debugLineNum = 222;BA.debugLine="xNome = c.CachedName";
_xnome = _c.CachedName;
 //BA.debugLineNum = 223;BA.debugLine="If xNome.Trim = \"\" Then";
if ((_xnome.trim()).equals("")) { 
 //BA.debugLineNum = 224;BA.debugLine="xNome = \"Unknow\"";
_xnome = "Unknow";
 };
 //BA.debugLineNum = 226;BA.debugLine="xTemp = c.Number";
_xtemp = _c.Number;
 //BA.debugLineNum = 227;BA.debugLine="xInt = xTemp.Length -1";
_xint = (int) (_xtemp.length()-1);
 //BA.debugLineNum = 228;BA.debugLine="Dim i As Int";
_i = 0;
 //BA.debugLineNum = 229;BA.debugLine="xNumero = \"\"";
_xnumero = "";
 //BA.debugLineNum = 230;BA.debugLine="For i = 0 To  xInt";
{
final int step156 = 1;
final int limit156 = _xint;
for (_i = (int) (0); (step156 > 0 && _i <= limit156) || (step156 < 0 && _i >= limit156); _i = ((int)(0 + _i + step156))) {
 //BA.debugLineNum = 231;BA.debugLine="xNumero = xNumero & xTemp.CharAt(i) & \" \"";
_xnumero = _xnumero+BA.ObjectToString(_xtemp.charAt(_i))+" ";
 }
};
 //BA.debugLineNum = 245;BA.debugLine="Dim Dias(), Meses(), xDia, xMes, xSemana, xAno, xHora, xMinuto As String";
_dias = new String[(int) (0)];
java.util.Arrays.fill(_dias,"");
_meses = new String[(int) (0)];
java.util.Arrays.fill(_meses,"");
_xdia = "";
_xmes = "";
_xsemana = "";
_xano = "";
_xhora = "";
_xminuto = "";
 //BA.debugLineNum = 246;BA.debugLine="Dim xInt_dia, xInt_mes  As Int";
_xint_dia = 0;
_xint_mes = 0;
 //BA.debugLineNum = 247;BA.debugLine="Dias = Array As String (\"sunday\",\"monday\",\"tuesday\",\"wednesday\",\"thrusday\",\"friday\",\"saturday\")";
_dias = new String[]{"sunday","monday","tuesday","wednesday","thrusday","friday","saturday"};
 //BA.debugLineNum = 248;BA.debugLine="Meses = Array As String (\"january\",\"february\",\"march\",\"april\",\"may\",\"june\",\"july\",\"august\",\"september\",\"october\",\"november\",\"december\")";
_meses = new String[]{"january","february","march","april","may","june","july","august","september","october","november","december"};
 //BA.debugLineNum = 250;BA.debugLine="xSemana = Dias( DateTime.GetDayOfWeek(c.Date) )";
_xsemana = _dias[anywheresoftware.b4a.keywords.Common.DateTime.GetDayOfWeek(_c.Date)];
 //BA.debugLineNum = 251;BA.debugLine="xMes = Meses(DateTime.GetMonth(c.Date)-1)";
_xmes = _meses[(int) (anywheresoftware.b4a.keywords.Common.DateTime.GetMonth(_c.Date)-1)];
 //BA.debugLineNum = 252;BA.debugLine="xDia = DateTime.Date(c.Date).SubString2(0,2)";
_xdia = anywheresoftware.b4a.keywords.Common.DateTime.Date(_c.Date).substring((int) (0),(int) (2));
 //BA.debugLineNum = 253;BA.debugLine="xAno =  DateTime.GetYear(c.Date)";
_xano = BA.NumberToString(anywheresoftware.b4a.keywords.Common.DateTime.GetYear(_c.Date));
 //BA.debugLineNum = 254;BA.debugLine="xData = xSemana & \", \" & xMes & \" \" & xDia & \" , \" & xAno & \",, \"";
_xdata = _xsemana+", "+_xmes+" "+_xdia+" , "+_xano+",, ";
 //BA.debugLineNum = 255;BA.debugLine="xHora = DateTime.GetHour(c.Date)";
_xhora = BA.NumberToString(anywheresoftware.b4a.keywords.Common.DateTime.GetHour(_c.Date));
 //BA.debugLineNum = 256;BA.debugLine="xMinuto = DateTime.GetMinute(c.Date)";
_xminuto = BA.NumberToString(anywheresoftware.b4a.keywords.Common.DateTime.GetMinute(_c.Date));
 //BA.debugLineNum = 257;BA.debugLine="xData = xData & \" \" & \"at\" & \" \" & xHora & \" \"  &  _ 	        \"hours e\" & \" \" & xMinuto & \" \" & \"minutes\"  & \" \"";
_xdata = _xdata+" "+"at"+" "+_xhora+" "+"hours e"+" "+_xminuto+" "+"minutes"+" ";
 //BA.debugLineNum = 260;BA.debugLine="If c.Duration > 3600 Then";
if (_c.Duration>3600) { 
 //BA.debugLineNum = 261;BA.debugLine="If NumberFormat((c.Duration/3600 ) , 0, 0) > 1 Then";
if ((double)(Double.parseDouble(anywheresoftware.b4a.keywords.Common.NumberFormat((_c.Duration/(double)3600),(int) (0),(int) (0))))>1) { 
 //BA.debugLineNum = 262;BA.debugLine="xDuracao = NumberFormat((c.Duration/3600 ) , 0, 0)  & \" \" & \"hours\" & \" \"";
_xduracao = anywheresoftware.b4a.keywords.Common.NumberFormat((_c.Duration/(double)3600),(int) (0),(int) (0))+" "+"hours"+" ";
 }else {
 //BA.debugLineNum = 264;BA.debugLine="xDuracao = NumberFormat((c.Duration/3600 ) , 0, 0) & \" \"  & \"hour\" & \" \"";
_xduracao = anywheresoftware.b4a.keywords.Common.NumberFormat((_c.Duration/(double)3600),(int) (0),(int) (0))+" "+"hour"+" ";
 };
 }else if(_c.Duration>60) { 
 //BA.debugLineNum = 267;BA.debugLine="If NumberFormat(( c.Duration / 60 ) , 0, 0) > 1 Then";
if ((double)(Double.parseDouble(anywheresoftware.b4a.keywords.Common.NumberFormat((_c.Duration/(double)60),(int) (0),(int) (0))))>1) { 
 //BA.debugLineNum = 268;BA.debugLine="xDuracao =  NumberFormat(( c.Duration / 60 ) , 0, 0) & \" \" & \"minutes\" & \" \"";
_xduracao = anywheresoftware.b4a.keywords.Common.NumberFormat((_c.Duration/(double)60),(int) (0),(int) (0))+" "+"minutes"+" ";
 }else {
 //BA.debugLineNum = 270;BA.debugLine="xDuracao =  NumberFormat(( c.Duration / 60 ) , 0, 0) & \" \" & \"minute\" & \" \"";
_xduracao = anywheresoftware.b4a.keywords.Common.NumberFormat((_c.Duration/(double)60),(int) (0),(int) (0))+" "+"minute"+" ";
 };
 }else {
 //BA.debugLineNum = 273;BA.debugLine="If c.Duration > 1 Then";
if (_c.Duration>1) { 
 //BA.debugLineNum = 274;BA.debugLine="xDuracao = c.Duration & \" \" & \"seconds\"";
_xduracao = BA.NumberToString(_c.Duration)+" "+"seconds";
 }else {
 //BA.debugLineNum = 276;BA.debugLine="xDuracao = c.Duration & \" \" & \"second\"";
_xduracao = BA.NumberToString(_c.Duration)+" "+"second";
 };
 };
 //BA.debugLineNum = 280;BA.debugLine="xTexto = \",, \" & \"Call\" & \", \"  & callType & \",\" & xNome & \",, \" &\"phone number\" & \" \" & xNumero & \",, \" & xData & \",, \" & \"total timee\" & \" \" & xDuracao";
_xtexto = ",, "+"Call"+", "+_calltype+","+_xnome+",, "+"phone number"+" "+_xnumero+",, "+_xdata+",, "+"total timee"+" "+_xduracao;
 //BA.debugLineNum = 282;BA.debugLine="TTS1.Speak(xTexto, True)";
_tts1.Speak(_xtexto,anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 285;BA.debugLine="End Sub";
return "";
}
}
